unit DetectROIDlgu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Buttons, ExtCtrls, Mpfileu;

type
  TDetectROIDlg = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    SpinEdit1: TSpinEdit;
    Label3: TLabel;
    SpinEdit2: TSpinEdit;
    CheckBox1: TCheckBox;
    GroupBox2: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton4: TRadioButton;
    GroupBox3: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    SpinEdit5: TSpinEdit;
    SpinEdit6: TSpinEdit;
    Label2: TLabel;
    SpinEdit3: TSpinEdit;
    Label4: TLabel;
    SpinEdit4: TSpinEdit;
  private
    { Private declarations }
  public
    { Public declarations }
    function	SelectedCh: integer;
    procedure	SetGUI(aMPFile: TMPFile);
  end;

var
  DetectROIDlg: TDetectROIDlg;

implementation

{$R *.DFM}


function	TDetectROIDlg.SelectedCh: integer;
begin
	if RadioButton1.Checked then
   	Result := 0
   else if RadioButton2.Checked then
   	Result :=1
   else if RadioButton3.Checked then
   	Result := 2
   else if RadioButton4.Checked then
   	Result := 3
   else
   	Result := 0;
end;

procedure	TDetectROIDlg.SetGUI(aMPFile: TMPFile);
begin
	with aMPFile do
   begin
   	RadioButton1.Checked := (DefaultVideoChannel = 0);
       RadioButton2.Checked := (DefaultVideoChannel = 1);
   	RadioButton3.Checked := (DefaultVideoChannel = 2);
       RadioButton4.Checked := (DefaultVideoChannel = 3);

       if VideoChCount = 1 then
       begin
       	RadioButton1.Enabled := False;
           RadioButton2.Enabled := False;
           RadioButton3.Enabled := False;
           RadioButton4.Enabled := False;
       end
       else
       begin
       	RadioButton1.Enabled := VideoChEnabled[0];
           RadioButton2.Enabled := VideoChEnabled[1];
           RadioButton3.Enabled := VideoChEnabled[2];
           RadioButton4.Enabled := VideoChEnabled[3];
       end;
   end;
end;


end.
