unit MPView_TLB;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : $Revision:   1.88  $
// File generated on 5/2/2007 4:58:45 AM from Type Library described below.

// *************************************************************************//
// NOTE:                                                                      
// Items guarded by $IFDEF_LIVE_SERVER_AT_DESIGN_TIME are used by properties  
// which return objects that may need to be explicitly created via a function 
// call prior to any access via the property. These items have been disabled  
// in order to prevent accidental use from within the object inspector. You   
// may enable them by defining LIVE_SERVER_AT_DESIGN_TIME or by selectively   
// removing them from the $IFDEF blocks. However, such items must still be    
// programmatically created via a method of the appropriate CoClass before    
// they can be used.                                                          
// ************************************************************************ //
// Type Lib: C:\Program Files\Borland\Delphi5\Projects\MPView\mpview.tlb (1)
// IID\LCID: {4C26053A-28E9-4A22-95CC-E09512476E78}\0
// Helpfile: 
// DepndLst: 
//   (1) v2.0 stdole, (C:\WINDOWS\system32\stdole2.tlb)
//   (2) v4.0 StdVCL, (C:\WINDOWS\system32\STDVCL40.DLL)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, OleCtrls, StdVCL;

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  MPViewMajorVersion = 1;
  MPViewMinorVersion = 0;

  LIBID_MPView: TGUID = '{4C26053A-28E9-4A22-95CC-E09512476E78}';

  IID_IApplication: TGUID = '{64A3498A-B1DC-4E40-A4C7-364489AD03BF}';
  CLASS_Application: TGUID = '{AB0D81AD-BE09-408F-8654-B0D6BBA4903F}';
  IID_IDataFile: TGUID = '{D3CE61EB-7B39-4F58-8ECD-67D56107924C}';
type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IApplication = interface;
  IApplicationDisp = dispinterface;
  IDataFile = interface;
  IDataFileDisp = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  Application = IApplication;


// *********************************************************************//
// Interface: IApplication
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {64A3498A-B1DC-4E40-A4C7-364489AD03BF}
// *********************************************************************//
  IApplication = interface(IDispatch)
    ['{64A3498A-B1DC-4E40-A4C7-364489AD03BF}']
    function  Get_OpenFileCount: Integer; safecall;
    procedure OpenDataFile(const fname: WideString); safecall;
    property OpenFileCount: Integer read Get_OpenFileCount;
  end;

// *********************************************************************//
// DispIntf:  IApplicationDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {64A3498A-B1DC-4E40-A4C7-364489AD03BF}
// *********************************************************************//
  IApplicationDisp = dispinterface
    ['{64A3498A-B1DC-4E40-A4C7-364489AD03BF}']
    property OpenFileCount: Integer readonly dispid 1;
    procedure OpenDataFile(const fname: WideString); dispid 2;
  end;

// *********************************************************************//
// Interface: IDataFile
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {D3CE61EB-7B39-4F58-8ECD-67D56107924C}
// *********************************************************************//
  IDataFile = interface(IDispatch)
    ['{D3CE61EB-7B39-4F58-8ECD-67D56107924C}']
    function  GetFileProperty(const propName: WideString): WideString; safecall;
    procedure LoadFrame(frameIndex: Integer); safecall;
  end;

// *********************************************************************//
// DispIntf:  IDataFileDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {D3CE61EB-7B39-4F58-8ECD-67D56107924C}
// *********************************************************************//
  IDataFileDisp = dispinterface
    ['{D3CE61EB-7B39-4F58-8ECD-67D56107924C}']
    function  GetFileProperty(const propName: WideString): WideString; dispid 1;
    procedure LoadFrame(frameIndex: Integer); dispid 2;
  end;

// *********************************************************************//
// The Class CoApplication provides a Create and CreateRemote method to          
// create instances of the default interface IApplication exposed by              
// the CoClass Application. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoApplication = class
    class function Create: IApplication;
    class function CreateRemote(const MachineName: string): IApplication;
  end;


// *********************************************************************//
// OLE Server Proxy class declaration
// Server Object    : TApplication
// Help String      : 
// Default Interface: IApplication
// Def. Intf. DISP? : No
// Event   Interface: 
// TypeFlags        : (2) CanCreate
// *********************************************************************//
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  TApplicationProperties= class;
{$ENDIF}
  TApplication = class(TOleServer)
  private
    FIntf:        IApplication;
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
    FProps:       TApplicationProperties;
    function      GetServerProperties: TApplicationProperties;
{$ENDIF}
    function      GetDefaultInterface: IApplication;
  protected
    procedure InitServerData; override;
    function  Get_OpenFileCount: Integer;
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
    procedure Connect; override;
    procedure ConnectTo(svrIntf: IApplication);
    procedure Disconnect; override;
    procedure OpenDataFile(const fname: WideString);
    property  DefaultInterface: IApplication read GetDefaultInterface;
    property OpenFileCount: Integer read Get_OpenFileCount;
  published
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
    property Server: TApplicationProperties read GetServerProperties;
{$ENDIF}
  end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
// *********************************************************************//
// OLE Server Properties Proxy Class
// Server Object    : TApplication
// (This object is used by the IDE's Property Inspector to allow editing
//  of the properties of this server)
// *********************************************************************//
 TApplicationProperties = class(TPersistent)
  private
    FServer:    TApplication;
    function    GetDefaultInterface: IApplication;
    constructor Create(AServer: TApplication);
  protected
    function  Get_OpenFileCount: Integer;
  public
    property DefaultInterface: IApplication read GetDefaultInterface;
  published
  end;
{$ENDIF}


procedure Register;

implementation

uses ComObj;

class function CoApplication.Create: IApplication;
begin
  Result := CreateComObject(CLASS_Application) as IApplication;
end;

class function CoApplication.CreateRemote(const MachineName: string): IApplication;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_Application) as IApplication;
end;

procedure TApplication.InitServerData;
const
  CServerData: TServerData = (
    ClassID:   '{AB0D81AD-BE09-408F-8654-B0D6BBA4903F}';
    IntfIID:   '{64A3498A-B1DC-4E40-A4C7-364489AD03BF}';
    EventIID:  '';
    LicenseKey: nil;
    Version: 500);
begin
  ServerData := @CServerData;
end;

procedure TApplication.Connect;
var
  punk: IUnknown;
begin
  if FIntf = nil then
  begin
    punk := GetServer;
    Fintf:= punk as IApplication;
  end;
end;

procedure TApplication.ConnectTo(svrIntf: IApplication);
begin
  Disconnect;
  FIntf := svrIntf;
end;

procedure TApplication.DisConnect;
begin
  if Fintf <> nil then
  begin
    FIntf := nil;
  end;
end;

function TApplication.GetDefaultInterface: IApplication;
begin
  if FIntf = nil then
    Connect;
  Assert(FIntf <> nil, 'DefaultInterface is NULL. Component is not connected to Server. You must call ''Connect'' or ''ConnectTo'' before this operation');
  Result := FIntf;
end;

constructor TApplication.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  FProps := TApplicationProperties.Create(Self);
{$ENDIF}
end;

destructor TApplication.Destroy;
begin
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  FProps.Free;
{$ENDIF}
  inherited Destroy;
end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
function TApplication.GetServerProperties: TApplicationProperties;
begin
  Result := FProps;
end;
{$ENDIF}

function  TApplication.Get_OpenFileCount: Integer;
begin
  Result := DefaultInterface.Get_OpenFileCount;
end;

procedure TApplication.OpenDataFile(const fname: WideString);
begin
  DefaultInterface.OpenDataFile(fname);
end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
constructor TApplicationProperties.Create(AServer: TApplication);
begin
  inherited Create;
  FServer := AServer;
end;

function TApplicationProperties.GetDefaultInterface: IApplication;
begin
  Result := FServer.DefaultInterface;
end;

function  TApplicationProperties.Get_OpenFileCount: Integer;
begin
  Result := DefaultInterface.Get_OpenFileCount;
end;

{$ENDIF}

procedure Register;
begin
  RegisterComponents('Servers',[TApplication]);
end;

end.
