unit fileinfou;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, ComCtrls, Spin, Mainfrm;

type
  TConfigdlg = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    CheckBox1: TCheckBox;
    Label2: TLabel;
    ComboBox2: TComboBox;
    Label3: TLabel;
    Edit1: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    SpinEdit4: TSpinEdit;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label1: TLabel;
    Label20: TLabel;
    CheckBox2: TCheckBox;
    Label21: TLabel;
    Edit2: TEdit;
    Label22: TLabel;
    ComboBox1: TComboBox;
    CheckBox3: TCheckBox;
    Edit3: TEdit;
    Label23: TLabel;
    Label24: TLabel;
    ComboBox3: TComboBox;
    Button1: TButton;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    ComboBox4: TComboBox;
    Edit4: TEdit;
    Edit5: TEdit;
    Label27: TLabel;
    SpinEdit6: TSpinEdit;
    Label28: TLabel;
    Bevel2: TBevel;
    Label29: TLabel;
    SpinButton1: TSpinButton;
    SpeedButton1: TSpeedButton;
    Edit9: TEdit;
    Edit10: TEdit;
    Label9: TLabel;
    CheckBox4: TCheckBox;
    Label18: TLabel;
    Edit6: TEdit;
    Label19: TLabel;
    ComboBox5: TComboBox;
    Label30: TLabel;
    Edit7: TEdit;
    Label31: TLabel;
    ComboBox6: TComboBox;
    Label32: TLabel;
    Edit8: TEdit;
    Label33: TLabel;
    Label34: TLabel;
    Edit11: TEdit;
    Label35: TLabel;
    SpinEdit5: TSpinEdit;
    Label36: TLabel;
    Bevel1: TBevel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label41: TLabel;
    Label42: TLabel;
    Label43: TLabel;
    Label44: TLabel;
    Label45: TLabel;
    Label40: TLabel;
    Label46: TLabel;
    Bevel3: TBevel;
    SpinButton2: TSpinButton;
    Label47: TLabel;
    Bevel4: TBevel;
    Label48: TLabel;
    Bevel5: TBevel;
    Label49: TLabel;
    Bevel6: TBevel;
    Label50: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit7Change(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure SpinEdit3Change(Sender: TObject);
    procedure SpinEdit4Change(Sender: TObject);
    procedure Edit9Change(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure Edit10Change(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure SpinEdit6Change(Sender: TObject);
    procedure Edit6Change(Sender: TObject);
    procedure ComboBox5Change(Sender: TObject);
    procedure Edit8Change(Sender: TObject);
    procedure Edit11Change(Sender: TObject);
    procedure SpinEdit5Change(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure SpinButton2DownClick(Sender: TObject);
    procedure SpinButton2UpClick(Sender: TObject);
  private
    { Private declarations }
    {Modification flags}
    bModified,
    bBlockEdit9Change,
    bFrameWidthChanged,
    bFrameHeightChanged,
    bFrameXOffsetChanged,
    bFrameYOffsetChanged,
    bFrameRateChanged,
    bCh1Changed,
    bCh2Changed,
    bCh3Changed,
    bCh3DataPtsChanged,
    bCh4Changed,
    bCh4DataPtsChanged: boolean;
    newPixelRate: integer;
    newFrameRate: double;

    procedure EnableCh1;
    procedure EnableCh2;
    procedure EnableCh3;
    procedure EnableCh4;
    procedure OnPixelRateChanged;
    procedure SetConvFactorUnit1;
    procedure SetConvFactorUnit2;

    function  ValidateFrameWidth(value: integer): boolean;
    function  ValidateFrameHeight(var value: integer): boolean;
    function  ValidateXOffset(value: integer): boolean;
    function  ValidateYOffset(value: integer): boolean;
    function  ValidateFrameRate(value: double): boolean;
    function  ValidateVideoChs: boolean;
    function  ValidateDataPtsCh(value: integer): boolean;


  public
    { Public declarations }
    bNoFrameDimChange: boolean;
  end;

var
  Configdlg: TConfigdlg;

implementation

{$R *.DFM}
uses MPUnit, Dialogs, Math;

procedure TConfigdlg.EnableCh1;
begin
   Edit1.Enabled := CheckBox1.Checked;
   ComboBox2.Enabled := CheckBox1.Checked;
end;


procedure TConfigdlg.EnableCh2;
begin
   Edit2.Enabled := CheckBox2.Checked;
   ComboBox1.Enabled := CheckBox2.Checked;
end;


procedure TConfigdlg.EnableCh3;
begin
   Edit3.Enabled := CheckBox3.Checked;
   ComboBox3.Enabled := CheckBox3.Checked;
   Edit5.Enabled := CheckBox3.Checked;
   ComboBox4.Enabled := CheckBox3.Checked;
   Edit10.Enabled := CheckBox3.Checked;
   Edit4.Enabled := CheckBox3.Checked;
   SpinEdit6.Enabled := CheckBox3.Checked;
   Label27.Enabled := CheckBox3.Checked;
   Label28.Enabled := CheckBox3.Checked;
   Label45.Enabled := CheckBox3.Checked;
end;


procedure TConfigdlg.EnableCh4;
begin
   Edit6.Enabled := CheckBox4.Checked;
   ComboBox5.Enabled := CheckBox4.Checked;
   Edit7.Enabled := CheckBox4.Checked;
   ComboBox6.Enabled := CheckBox4.Checked;
   Edit8.Enabled := CheckBox4.Checked;
   Edit11.Enabled := CheckBox4.Checked;
   SpinEdit5.Enabled := CheckBox4.Checked;
   Label33.Enabled := CheckBox4.Checked;
   Label37.Enabled := CheckBox4.Checked;
   Label44.Enabled := CheckBox3.Checked;
end;


procedure TConfigdlg.OnPixelRateChanged;
begin
   Label46.Caption := IntToStr(newPixelRate * 50) + ' ns';
   Label48.Caption := Format('%4.2f', [1e3/(newPixelRate * 50)]) + ' MHz';
   Label28.Caption := Format('%5f', [newFrameRate * SpinEdit6.Value]);
   Label37.Caption := Format('%5f', [newFrameRate * SpinEdit5.Value]);
end;


procedure TConfigdlg.SetConvFactorUnit1;
begin
   Label27.Caption := ComboBox4.Items[ComboBox4.ItemIndex] + Edit5.Text + '/ V at input';
   Label45.Caption := ComboBox4.Items[ComboBox4.ItemIndex] + Edit5.Text;
end;


procedure TConfigdlg.SetConvFactorUnit2;
begin
   Label33.Caption :=  ComboBox6.Items[ComboBox6.ItemIndex] + Edit7.Text + '/ V at input';
   Label44.Caption :=  ComboBox6.Items[ComboBox6.ItemIndex] + Edit7.Text;
end;


function  TConfigdlg.ValidateFrameWidth(value: integer): boolean;
begin
   Result := (value >= 10) and (value <= 500);
end;


function  TConfigdlg.ValidateFrameHeight(var value: integer): boolean;
begin
   Result := (value >= 10) and (value <= 500);
   if Result and Odd(value) then
   begin
       MessageDlg('Frame height will be adjusted to be a multiple of 2 lines.',
           mtInformation, [mbOK], 0);
       value := 2 * (value div 2);
       if value < 10 then value := 10;
   end;
end;


function  TConfigdlg.ValidateXOffset(value: integer): boolean;
begin
   Result := (value >= 0) and (value <= 490);
end;


function  TConfigdlg.ValidateYOffset(value: integer): boolean;
begin
   Result := (value >= 0) and (value <= 490);
end;


function  TConfigdlg.ValidateFrameRate(value: double): boolean;
var    valFrameRate: double;
       valPixelRate: integer;
begin
   Mainform.Configuration.GetMaxFrameRate(SpinEdit1.Value, SpinEdit2.Value, valFrameRate, valPixelRate);
   Result := (value > 0) and (value <= valFrameRate);
end;


function  TConfigdlg.ValidateVideoChs: boolean;
begin
   Result := Checkbox1.Checked or Checkbox2.Checked;
end;


function  TConfigdlg.ValidateDataPtsCh(value: integer): boolean;
begin
   Result := (value >= 0) and (value <= spinEdit1.Value * spinEdit2.Value);
end;


procedure TConfigdlg.FormShow(Sender: TObject);
begin
   bModified := False;

   with mainform.Configuration do
   begin
       Label50.Caption := ScanModeToString(ScanMode);
       if not bNoFrameDimChange then
       begin
           SpinEdit1.Value := FrameWidth;
           SpinEdit2.Value := FrameHeight;
           SpinEdit3.Value := XFrameOffset;
           SpinEdit4.Value := YFrameOffset;
           newFrameRate := FrameRate;
           newPixelRate := PixelClock;
       end
       else
       begin
           bModified := True; {main form has modified it}
           GetMaxFrameRate(SpinEdit1.Value, SpinEdit2.Value, newFrameRate, newPixelRate);
       end;

       bBlockEdit9Change := True;
       Edit9.Text := Format('%f', [newFrameRate]);
       bBlockEdit9Change := False;
       OnPixelRateChanged;

       CheckBox1.Checked := ChEnabled[0];
       Edit1.Text := ChNames[0];
       ComboBox2.ItemIndex := Integer(ChInputRanges[0]);

       CheckBox2.Checked := ChEnabled[1];
       Edit2.Text := ChNames[1];
       ComboBox1.ItemIndex := Integer(ChInputRanges[1]);

       CheckBox3.Checked := ChEnabled[2];
       Edit3.Text := ChNames[2];
       ComboBox3.ItemIndex := Integer(ChInputRanges[2]);
       Edit5.Text := ChUnits[2];
       ComboBox4.ItemIndex := Integer(ChPrefixes[2]);
       Edit4.Text := Format('%g', [ChOffsets[2]]);
       SpinEdit6.Value := ChDataPtsPerFrames[2];
       Label28.Caption := Format('%f', [ChAnalogFreqs[2]]);

       SetConvFactorUnit1;

       CheckBox4.Checked := ChEnabled[3];
       Edit6.Text := ChNames[3];
       ComboBox5.ItemIndex := Integer(ChInputRanges[3]);
       Edit7.Text := ChUnits[3];
       ComboBox6.ItemIndex := Integer(ChPrefixes[3]);
       Edit11.Text := Format('%g', [ChOffsets[3]]);
       SpinEdit5.Value := ChDataPtsPerFrames[3];
       Label37.Caption := Format('%f', [ChAnalogFreqs[2]]);

       SetConvFactorUnit2;

       EnableCh1;
       EnableCh2;
       EnableCh3;
       EnableCh4;
   end;
   bFrameWidthChanged := False;
   bFrameHeightChanged := False;
   bFrameXOffsetChanged := False;
   bFrameYOffsetChanged := False;
   bFrameRateChanged := False;
   bCh1Changed := False;
   bCh2Changed := False;
   bCh3Changed := False;
   bCh3DataPtsChanged := False;
   bCh4Changed := False;
   bCh4DataPtsChanged := False;
end;


procedure TConfigdlg.FormCreate(Sender: TObject);
begin
   FillInputRangeListBox(ComboBox2);
   FillInputRangeListBox(ComboBox1);
   FillInputRangeListBox(ComboBox3);
   FillInputRangeListBox(ComboBox5);

   FillUnitListBox(ComboBox4, '');
   FillUnitListBox(ComboBox6, '');
end;


procedure TConfigdlg.Edit7Change(Sender: TObject);
begin
   SetConvFactorUnit2;
   bModified := True;
end;


procedure TConfigdlg.Edit5Change(Sender: TObject);
begin
   SetConvFactorUnit1;
   bModified := True;
end;


procedure TConfigdlg.CheckBox1Click(Sender: TObject);
begin
   EnableCh1;
   bModified := True; bCh1Changed := True;
end;


procedure TConfigdlg.CheckBox2Click(Sender: TObject);
begin
   EnableCh2;
   bModified := True; bCh2Changed := True;
end;


procedure TConfigdlg.CheckBox3Click(Sender: TObject);
begin
   EnableCh3;
   bModified := True;
   bCh3Changed := True;
end;


procedure TConfigdlg.CheckBox4Click(Sender: TObject);
begin
   EnableCh4;
   bModified := True;
   bCh4Changed := True;
end;


procedure TConfigdlg.SpeedButton1Click(Sender: TObject);
begin
   Mainform.Configuration.GetMaxFrameRate(SpinEdit1.Value, SpinEdit2.Value, newFrameRate, newPixelRate);
   bBlockEdit9Change := True;
   Edit9.Text := Format('%f', [newFrameRate]);
   bBlockEdit9Change := False;
   OnPixelRateChanged;
   bModified := True;
end;


procedure TConfigdlg.Button1Click(Sender: TObject);
begin
   SpinEdit1.Value := 500;
   SpinEdit2.Value := 500;
   SpinEdit3.Value := 0;
   SpinEdit4.Value := 0;
   Edit9.Text := '4';
   CheckBox1.Enabled := True;
   ComboBox2.ItemIndex := 0;
   CheckBox2.Enabled := False;
   CheckBox3.Enabled := False;
   CheckBox4.Enabled := False;
   bModified := True;
end;

resourcestring
   sFrameWidthNotOK = 'Frame width must be between 10 and 500.';
   sFrameHeightNotOK = 'Frame height must be between 10 and 500.';
   sFrameXOffsetNotOK = 'Frame X-offset must be between 0 and 490.';
   sFrameYOffsetNotOK = 'Frame Y-offset must be between 0 and 490.';
   sFrameRateNotOK = 'Invalid Frame Rate.';
   sVideoChCountNotOK = 'At least one video channel must be enabled.';
   sDataPtsPerFrameNotOKCh1 = 'Invalid number of data points / frame in Analog Ch 1.';
   sDataPtsPerFrameNotOKCh2 = 'Invalid number of data points / frame in Analog Ch 2.';
   sFrameTooSmall = 'Selected frame is too small.' + CRLF  +
                    'Frames must have at least 512 pixels.';


procedure TConfigdlg.BitBtn1Click(Sender: TObject);
var    bValueOK: boolean;
       fh: integer;
begin
   bValueOK := True;
   if bModified then
   try
       with mainform.Configuration do
       begin
           {Test critical parameters}
           if bValueOK and bFrameWidthChanged then bValueOK := ValidateFrameWidth(SpinEdit1.Value);
           if not bValueOK then
           begin
               MessageDlg(sFrameWidthNotOK, mtError, [mbOK], 0);
               SpinEdit1.Value := FrameWidth;
               PageControl1.ActivePage := TabSheet1;
           end;

           fh := SpinEdit2.Value;
           if bValueOK and bFrameHeightChanged then bValueOK := ValidateFrameHeight(fh);
           if not bValueOK then
           begin
               MessageDlg(sFrameHeightNotOK, mtError, [mbOK], 0);
               SpinEdit2.Value := FrameHeight;
               PageControl1.ActivePage := TabSheet1;
           end
           else
               SpinEdit2.Value := fh;

           {for double-buffered DMA using the FIFO buffer, the number of samples
           transferred by WFM_Load must be larger than 2048 samples = 2 channels
               * 2 frames * total number of pixels}
           if bValueOK then
               if Muldiv(SpinEdit1.Value, 5, 4) * SpinEdit2.Value < 512 then
               begin
                   MessageDlg(sFrameTooSmall, mtError, [mbOK], 0);
                   PageControl1.ActivePage := TabSheet1;
                   bValueOK := False;
               end;

           if bValueOK and bFrameXOffsetChanged then bValueOK := ValidateXOffset(SpinEdit3.Value);
           if not bValueOK then
           begin
               MessageDlg(sFrameXOffsetNotOK, mtError, [mbOK], 0);
               SpinEdit3.Value := XFrameOffset;
               PageControl1.ActivePage := TabSheet1;
           end;

           if bValueOK and bFrameYOffsetChanged then bValueOK := ValidateYOffset(SpinEdit4.Value);
           if not bValueOK then
           begin
               MessageDlg(sFrameYOffsetNotOK, mtError, [mbOK], 0);
               SpinEdit4.Value := YFrameOffset;
               PageControl1.ActivePage := TabSheet1;
           end;

           if bValueOK and bFrameRateChanged then bValueOK := ValidateFrameRate(StrToFloat(Edit9.Text));
           if not bValueOK then
           begin
               MessageDlg(sFrameRateNotOK, mtError, [mbOK], 0);
               Edit9.Text := Format('%f', [FrameRate]);
               PageControl1.ActivePage := TabSheet1;
           end;

           if bValueOK and (bCh1Changed or bCh2Changed) then bValueOK := ValidateVideoChs;
           if not bValueOK then
           begin
               MessageDlg(sVideoChCountNotOK, mtError, [mbOK], 0);
               CheckBox1.Checked := True;
               PageControl1.ActivePage := TabSheet2;
           end;

           if bValueOK and bCh3DataPtsChanged then bValueOK := ValidateDataPtsCh(SpinEdit6.Value);
           if not bValueOK then
           begin
               MessageDlg(sDataPtsPerFrameNotOKCh1, mtError, [mbOK], 0);
               SpinEdit6.Value := ChDataPtsPerFrames[2];
               PageControl1.ActivePage := TabSheet4;
           end;

           if bValueOK and bCh4DataPtsChanged then bValueOK := ValidateDataPtsCh(SpinEdit5.Value);
           if not bValueOK then
           begin
               MessageDlg(sDataPtsPerFrameNotOKCh2, mtError, [mbOK], 0);
               SpinEdit5.Value := ChDataPtsPerFrames[3];
               PageControl1.ActivePage := TabSheet5;
           end;

           if bValueOK then
           begin
               {Saves current configuration}
               CopyTo(Mainform.prevConfig);

               {stuff results back}
               FrameWidth := SpinEdit1.Value;
               FrameHeight := (SpinEdit2.Value div 2) * 2; {even number of lines}
               XFrameOffset := SpinEdit3.Value;
               YFrameOffset := SpinEdit4.Value;
               PixelClock := newPixelRate;

               ChEnabled[0] := CheckBox1.Checked;
               ChNames[0] := Edit1.Text;
               ChInputRanges[0] := TFullScaleVal(ComboBox2.ItemIndex);

               ChEnabled[1] := CheckBox2.Checked;
               ChNames[1] := Edit2.Text;
               ChInputRanges[1] := TFullScaleVal(ComboBox1.ItemIndex);

               ChEnabled[2] := CheckBox3.Checked;
               ChNames[2] := Edit3.Text;
               ChInputRanges[2] := TFullScaleVal(ComboBox3.ItemIndex);
               ChUnits[2] := Edit5.Text;
               ChPrefixes[2] := TPrefix(ComboBox4.ItemIndex);
               ChOffsets[2] := StrToFloat(Edit4.Text);
               ChDataPtsPerFrames[2] := SpinEdit6.Value;

               ChEnabled[3] := CheckBox4.Checked;
               ChNames[3] := Edit6.Text;
               ChInputRanges[3] := TFullScaleVal(ComboBox5.ItemIndex);
               ChUnits[3] := Edit7.Text;
               ChPrefixes[3] := TPrefix(ComboBox6.ItemIndex);
               ChOffsets[3] := StrToFloat(Edit11.Text);
               ChDataPtsPerFrames[3] := SpinEdit5.Value;
               
               ModalResult := mrOK;
           end
           else
               ModalResult := mrNone;
   end;
   except
       ModalResult := mrNone;
       if bValueOK then Raise; {show the original error message}
   end;
end;


procedure TConfigdlg.SpinEdit1Change(Sender: TObject);
begin
   bModified := True; bFrameWidthChanged := True;
end;

procedure TConfigdlg.SpinEdit2Change(Sender: TObject);
begin
   bModified := True; bFrameHeightChanged := True;
end;

procedure TConfigdlg.SpinEdit3Change(Sender: TObject);
begin
   bModified := True; bFrameXOffsetChanged := True;
end;

procedure TConfigdlg.SpinEdit4Change(Sender: TObject);
begin
   bModified := True; bFrameYOffsetChanged := True;
end;

procedure TConfigdlg.Edit9Change(Sender: TObject);
begin
   if bBlockEdit9Change then Exit;
   bModified := True; bFrameRateChanged := True;
   if Mainform.Configuration.FrameRateToPixelRate
       (StrToFloat(Edit9.Text), SpinEdit1.Value, SpinEdit2.Value, newPixelRate) then
   begin
       Mainform.Configuration.
           PixelRateToFrameRate(newPixelRate, SpinEdit1.Value, SpinEdit2.Value, newFrameRate);
       bBlockEdit9Change := True;
       Edit9.Text := Format('%f', [newFrameRate]);
       bBlockEdit9Change := False;
       OnPixelRateChanged;
   end;
end;

procedure TConfigdlg.Edit1Change(Sender: TObject);
begin
   bModified := True;
end;

procedure TConfigdlg.ComboBox2Change(Sender: TObject);
begin
   bModified := True;
end;

procedure TConfigdlg.Edit2Change(Sender: TObject);
begin
   bModified := True;
end;

procedure TConfigdlg.ComboBox1Change(Sender: TObject);
begin
   bModified := True;
end;

procedure TConfigdlg.Edit3Change(Sender: TObject);
begin
   bModified := True;
end;

procedure TConfigdlg.ComboBox3Change(Sender: TObject);
begin
   bModified := True;
end;

procedure TConfigdlg.Edit10Change(Sender: TObject);
begin
   bModified := True;
end;

procedure TConfigdlg.Edit4Change(Sender: TObject);
begin
   bModified := True;
end;

procedure TConfigdlg.SpinEdit6Change(Sender: TObject);
begin
   bModified := True; bCh3DataPtsChanged := True;
   Label28.Caption := Format('%5f', [newFrameRate * SpinEdit6.Value]);
end;

procedure TConfigdlg.Edit6Change(Sender: TObject);
begin
   bModified := True;
end;

procedure TConfigdlg.ComboBox5Change(Sender: TObject);
begin
   bModified := True;
end;

procedure TConfigdlg.Edit8Change(Sender: TObject);
begin
   bModified := True;
end;

procedure TConfigdlg.Edit11Change(Sender: TObject);
begin
   bModified := True;
end;

procedure TConfigdlg.SpinEdit5Change(Sender: TObject);
begin
   bModified := True; bCh4DataPtsChanged := True;
   Label37.Caption := Format('%5f', [newFrameRate * SpinEdit5.Value]);
end;

procedure TConfigdlg.SpinButton1DownClick(Sender: TObject);
var    freq: double;
       bChangingPixelRate: boolean;
       changedPixelRate: integer;
begin
   try
       freq := StrToFloat(Edit9.Text);
       if freq < 1 then Exit;
       bChangingPixelRate := False;

       repeat
           freq := freq - 1;
           if freq >= 0.5 then
           begin
               Mainform.Configuration.FrameRateToPixelRate
               (freq, SpinEdit1.Value, SpinEdit2.Value, changedPixelRate);
               if (changedPixelRate <> newPixelRate) then bChangingPixelRate := True;
           end;
       until bChangingPixelRate or (freq < 0.5);

       if  bChangingPixelRate then
       begin
           newPixelRate := changedPixelRate;
           OnPixelRateChanged;
           Mainform.Configuration.PixelRateToFrameRate
               (newPixelRate, SpinEdit1.Value, SpinEdit2.Value, newFrameRate);
           bBlockEdit9Change := True;
           Edit9.Text := Format('%f', [newFrameRate]);
           bBlockEdit9Change := False;
       end;
   except
       mainform.Configuration.GetMaxFrameRate(SpinEdit1.Value, SpinEdit2.Value, newFrameRate, newPixelRate);
       bBlockEdit9Change := True;
       Edit9.Text := Format('%f', [newFrameRate]);
       OnPixelRateChanged;
       bBlockEdit9Change := False;
   end;
   bModified := True; bFrameRateChanged := True;
end;


procedure TConfigdlg.SpinButton1UpClick(Sender: TObject);
var    freq: double;
       bChangingPixelRate: boolean;
       changedPixelRate: integer;
begin
   try
       freq := StrToFloat(Edit9.Text);
       if freq > 1000 then Exit;
       bChangingPixelRate := False;

       repeat
           freq := freq + 1;
           if freq < 1000 then
           begin
               Mainform.Configuration.FrameRateToPixelRate
               (freq, SpinEdit1.Value, SpinEdit2.Value, changedPixelRate);
               if (changedPixelRate <> newPixelRate) then bChangingPixelRate := True;
           end;
       until bChangingPixelRate or (freq >= 1000);

       if  bChangingPixelRate then
       begin
           newPixelRate := changedPixelRate;
           OnPixelRateChanged;
           Mainform.Configuration.PixelRateToFrameRate
               (newPixelRate, SpinEdit1.Value, SpinEdit2.Value, newFrameRate);
           bBlockEdit9Change := True;
           Edit9.Text := Format('%f', [newFrameRate]);
           bBlockEdit9Change := False;
       end;
   except
       mainform.Configuration.GetMaxFrameRate(SpinEdit1.Value, SpinEdit2.Value, newFrameRate, newPixelRate);
       bBlockEdit9Change := True;
       Edit9.Text := Format('%f', [newFrameRate]);
       bBlockEdit9Change := False;
       OnPixelRateChanged;
   end;
   bModified := True; bFrameRateChanged := True;
end;


procedure TConfigdlg.SpinButton2DownClick(Sender: TObject);
begin
   if newPixelRate > 8 then newPixelRate := newPixelRate - 1;
   if not Mainform.Configuration.PixelRateToFrameRate
       (newPixelRate, SpinEdit1.Value, SpinEdit2.Value, newFrameRate) then
       MessageDlg('Pixel Rate too fast for X- mirror to follow.', mtInformation, [mbOK], 0);
   bModified := True; bFrameRateChanged := True;
   bBlockEdit9Change := True;
   Edit9.Text := Format('%f', [newFrameRate]);
   bBlockEdit9Change := False;
   OnPixelRateChanged;
end;


procedure TConfigdlg.SpinButton2UpClick(Sender: TObject);
begin
   if newPixelRate < 999 then newPixelRate := newPixelRate + 1;
   if not Mainform.Configuration.PixelRateToFrameRate
       (newPixelRate, SpinEdit1.Value, SpinEdit2.Value, newFrameRate) then
       MessageDlg('Pixel Rate too fast for X- mirror to follow.', mtInformation, [mbOK], 0);
   bBlockEdit9Change := True;
   Edit9.Text := Format('%f', [newFrameRate]);
   bBlockEdit9Change := False;
   bModified := True; bFrameRateChanged := True;
   OnPixelRateChanged;
end;



end.
