unit opframedlgu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Spin,MPFileu;

type
  TOpFrameDlg = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ComboBox1: TComboBox;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    Label4: TLabel;
    SpinEdit3: TSpinEdit;
    Label5: TLabel;
    SpinEdit4: TSpinEdit;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
  private
    { Private declarations }
  public
    { Public declarations }
    procedure	InitGUI(afile: TMPFile);
    function   SelectedCh: integer;
  end;

var
  OpFrameDlg: TOpFrameDlg;

implementation

{$R *.DFM}

procedure	TOpFrameDlg.InitGUI(afile: TMPFile);
begin
	with afile do
   begin
   	RadioButton1.Checked := (DefaultVideoChannel = 0);
       RadioButton2.Checked :=  (DefaultVideoChannel = 1);
       RadioButton3.Checked :=  (DefaultVideoChannel = 2);
       RadioButton4.Checked :=  (DefaultVideoChannel = 3);

       if VideoChCount = 1 then
       begin
       	RadioButton1.Enabled := False;
           RadioButton2.Enabled := False;
           RadioButton3.Enabled := False;
           RadioButton4.Enabled := False;
       end
       else
       begin
       	RadioButton1.Enabled := ChEnabled[0];
           RadioButton2.Enabled := ChEnabled[1];
           RadioButton3.Enabled := ChEnabled[2];
           RadioButton4.Enabled := ChEnabled[3];
       end;
   end;
end;


function   TOpFrameDlg.SelectedCh: integer;
begin
	if RadioButton1.Checked then
   	Result := 0
   else if RadioButton2.Checked then
   	Result := 1
   else if RadioButton3.Checked then
   	Result := 2
   else if RadioButton4.Checked then
   	Result := 3
   else
   	Result := 0;
end;

end.
