unit fileinfodlgu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ExtCtrls, mpfileu;

type
  TFileInfoDlg = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    BitBtn1: TBitBtn;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    GroupBox1: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Bevel1: TBevel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label11: TLabel;
    Label2: TLabel;
    Bevel2: TBevel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Bevel3: TBevel;
    Label18: TLabel;
    Label19: TLabel;
    Bevel4: TBevel;
    Label20: TLabel;
    Bevel5: TBevel;
    Label21: TLabel;
    Bevel6: TBevel;
    Label22: TLabel;
    GroupBox3: TGroupBox;
    Bevel7: TBevel;
    Label23: TLabel;
    Label6: TLabel;
    Label24: TLabel;
    Bevel8: TBevel;
    Label25: TLabel;
    GroupBox4: TGroupBox;
    Bevel9: TBevel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Bevel10: TBevel;
    Label10: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Bevel11: TBevel;
    Label28: TLabel;
    Label29: TLabel;
    Bevel12: TBevel;
    Label32: TLabel;
    Label33: TLabel;
    Bevel14: TBevel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label39: TLabel;
    Label38: TLabel;
    Bevel15: TBevel;
    Label40: TLabel;
    Label41: TLabel;
    Label42: TLabel;
    Label43: TLabel;
    Bevel16: TBevel;
    Label44: TLabel;
    Label45: TLabel;
    Bevel17: TBevel;
    Label46: TLabel;
    Bevel18: TBevel;
    Label47: TLabel;
    Label48: TLabel;
    Label49: TLabel;
    Bevel19: TBevel;
    Label50: TLabel;
    Label51: TLabel;
    Bevel20: TBevel;
    Label52: TLabel;
    Label53: TLabel;
    Bevel21: TBevel;
    Label54: TLabel;
    Label55: TLabel;
    Bevel22: TBevel;
    Label56: TLabel;
    Label57: TLabel;
    Bevel23: TBevel;
    Label58: TLabel;
    Label59: TLabel;
    Bevel24: TBevel;
    Label60: TLabel;
    Label61: TLabel;
    Bevel25: TBevel;
    Label62: TLabel;
    Label63: TLabel;
    Bevel26: TBevel;
    Label64: TLabel;
    Label65: TLabel;
    Bevel27: TBevel;
    Label66: TLabel;
    Label67: TLabel;
    Bevel28: TBevel;
    Label70: TLabel;
    Label71: TLabel;
    Bevel30: TBevel;
    Label72: TLabel;
    Label73: TLabel;
    Bevel31: TBevel;
    Label68: TLabel;
    Label69: TLabel;
    Bevel29: TBevel;
    Label74: TLabel;
    Label75: TLabel;
    Bevel32: TBevel;
    Label76: TLabel;
    Label77: TLabel;
    Bevel33: TBevel;
    Label78: TLabel;
    Label79: TLabel;
    Bevel34: TBevel;
    Label80: TLabel;
    Label81: TLabel;
    Bevel35: TBevel;
    Label82: TLabel;
    Label83: TLabel;
    Bevel36: TBevel;
    Label84: TLabel;
    Label85: TLabel;
    Bevel37: TBevel;
    Label86: TLabel;
    Label87: TLabel;
    Bevel38: TBevel;
    Label88: TLabel;
    Label89: TLabel;
    Bevel39: TBevel;
    Label90: TLabel;
    Label91: TLabel;
    Label92: TLabel;
    Label93: TLabel;
    GroupBox5: TGroupBox;
    Label30: TLabel;
    Label31: TLabel;
    Bevel13: TBevel;
    Label94: TLabel;
    Label95: TLabel;
    Bevel40: TBevel;
    Label96: TLabel;
    Label97: TLabel;
    Bevel41: TBevel;
    Label98: TLabel;
    Label99: TLabel;
    Memo1: TMemo;
    Label100: TLabel;
    Bevel42: TBevel;
    Label101: TLabel;
    Label102: TLabel;
    Label103: TLabel;
    GroupBox6: TGroupBox;
    Edit1: TEdit;
    Edit2: TEdit;
    SpeedButton1: TSpeedButton;
    Label106: TLabel;
    Label107: TLabel;
    Bevel44: TBevel;
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
    fMPFile: TMPFile;
  public
    { Public declarations }
    procedure Fill(aMPFile: TMPFile);
  end;

var
  FileInfoDlg: TFileInfoDlg;

implementation

{$R *.DFM}

uses mpviewu;


procedure TFileInfoDlg.Fill(aMPFile: TMPFile);
begin
   with aMPFile do
   begin
   	fMPFile := aMPFile;
       Caption := 'File Information - ' + ExtractFileName(aMPFile.Filename);
       {File page}
       Label20.Caption := ScanModeToString(ScanMode);
       Label22.Caption := IntToStr(FrameCount);
       Label107.Caption := Resolution;
       Label12.Caption := IntToStr(XStagePosition);
       Label2.Caption := IntToStr(YStagePosition);
       Label17.Caption := FloatToStr(ZStagePosition);
       Label97.Caption := IntToStr(StackFrameCount);
       Label95.Caption := FloatToStr(StackInterval);
       Label31.Caption := IntToStr(StackAveragingCount);
       Label101.Caption := IntToStr(StackRepeatCount);
       Memo1.Text := comments;
       {Frame page}
       Label7.Caption := 'x' + FloatToStr(Magnification);
       Label10.Caption := IntToStr(Rotation) + Chr(186);
       Label23.Caption := IntToStr(XFrameOffset);
       Label25.Caption := IntToStr(YFrameOffset);
       Label27.Caption := IntToStr(FrameWidth);
       Label29.Caption := IntToStr(FrameHeight);
       Label33.Caption := Format('%6.2f', [FrameRate]);
       Label40.Caption := IntToStr(50 * PixelClock); {50 ns * pixel clock value}
       {Video Ch 1 page}
       Label43.Caption := BoolToString(ChEnabled[0]);
       Label45.Caption := ChNames[0];
       Label47.Caption := InputRangeToString(ChInputRange[0]);
       {Video Ch 2 page}
       Label49.Caption := BoolToString(ChEnabled[1]);
       Label51.Caption := ChNames[1];
       Label53.Caption := InputRangeToString(ChInputRange[1]);
       {Analog Ch3 page}
       Label60.Visible := AnalogChEnabled[2];
       Label62.Visible := AnalogChEnabled[2];
       Label64.Visible := AnalogChEnabled[2];
       Label66.Visible := AnalogChEnabled[2];
       Label70.Visible := AnalogChEnabled[2];
       Label72.Visible := AnalogChEnabled[2];

       Label55.Caption := BoolToString(ChEnabled[2]);
       Label57.Caption := ChNames[2];
       Label59.Caption := InputRangeToString(ChInputRange[2]);

       Label61.Visible := AnalogChEnabled[2]; Label61.Caption := ChUnit[2];
       Label63.Visible := AnalogChEnabled[2]; Label63.Caption := PrefixToString(ChPrefix[2]);
       Label65.Visible := AnalogChEnabled[2]; Label65.Caption := FloatToStr(ChConvFactor[2]);
       Label67.Visible := AnalogChEnabled[2]; Label67.Caption := FloatToStr(ChOffset[2]);
       Label71.Visible := AnalogChEnabled[2]; Label71.Caption := IntToStr(ChDataPtsPerFrame[2]);
       Label73.Visible := AnalogChEnabled[2]; Label73.Caption := Format('%6.2f', [ChAcquisitionRate[2]]);
		Label90.Visible := AnalogChEnabled[2];
       Label90.Caption := PrefixToString(ChPrefix[2]) +  ChUnit[2] +
           '/V at converter input';
       Label91.Visible := AnalogChEnabled[2]; Label91.Caption := PrefixToString(ChPrefix[2]) +  ChUnit[2];

       {Analog Ch4 page}
       Label78.Visible := AnalogChEnabled[3];
       Label80.Visible := AnalogChEnabled[3];
       Label82.Visible := AnalogChEnabled[3];
       Label84.Visible := AnalogChEnabled[3];
       Label86.Visible := AnalogChEnabled[3];
       Label88.Visible := AnalogChEnabled[3];

       Label69.Caption := BoolToString(ChEnabled[3]);
       Label75.Caption := ChNames[3];
       Label77.Caption := InputRangeToString(ChInputRange[3]);

       Label79.Visible := AnalogChEnabled[3]; Label79.Caption := ChUnit[3];
       Label81.Visible := AnalogChEnabled[3]; Label81.Caption := PrefixToString(ChPrefix[3]);
       Label83.Visible := AnalogChEnabled[3]; Label83.Caption := FloatToStr(ChConvFactor[3]);
       Label85.Visible := AnalogChEnabled[3]; Label85.Caption := FloatToStr(ChOffset[3]);
       Label87.Caption := IntToStr(ChDataPtsPerFrame[3]);
       Label89.Visible := AnalogChEnabled[3]; Label89.Caption := Format('%6.2f', [ChAcquisitionRate[3]]);
       Label92.Visible := AnalogChEnabled[3];
       Label92.Caption := PrefixToString(ChPrefix[3]) +  ChUnit[3] +
           '/V at converter input';
       Label93.Visible := AnalogChEnabled[3];
       Label93.Caption := PrefixToString(ChPrefix[3]) +  ChUnit[3];

       if IsVideoChannel[2] then TabSheet4.Caption := 'Imaging Ch 3' else TabSheet4.Caption := 'Analog Ch 1';
       if IsVideoChannel[3] then TabSheet5.Caption := 'Imaging Ch 4' else TabSheet5.Caption := 'Analog Ch 2';
   end;
end;



procedure TFileInfoDlg.SpeedButton1Click(Sender: TObject);
begin
	Edit2.Text := fMPFile.GetPropertyValue(Edit1.Text);
end;

end.
